/**
 * Interface a buntetesekhez.
 * A Smith-Waterman algoritmus ennek az interface-nek megfelelo
 * buntetofuggvenyeket fogad el.
 * @author Dombai Balazs
 */
public interface IPenalty {
    /**
     * Inicializalas.
     * @param str1 elso szekvencia
     * @param str2 masodik szekvencia
     */
    public void init(String str1, String str2) ;
    /** 
     * Futtatas. 
     */
    public void run() ;
    /**
     * Kiszamitott matrix visszaadasa.
     * @return a kiszamitott matrix
     */
    public int[][] getMatrix() ;
    /**
     * Az iranymatrix visszaadasa, ebbol kaphatjuk meg az optimalis illesztest.
     * @return iranymatrix
     */
    public int[][] getDirectionMatrix() ;
    /**
     * Maximalis elem keresese a kiszamolt matrixban, ezzel kapjuk meg a
     * legjobb lokalis illeszkedes erteket.
     * @return a maximalis elem
     */
    public int findMax();
    /**
     * A findMax() altal megkeresett maximalis ertek elso koordinatajanak
     * visszaadasa.
     */
    public int get_max1();
    /**
     * A findMax() altal megkeresett maximalis ertek masodik koordinatajanak
     * visszaadasa.
     */
    public int get_max2();
    
    static final int STOP = 0;
    static final int UPLEFT = 1;
    static final int UP = 2;
    static final int LEFT = 3;    
}
