/***
 * t, r, mu, lambda tarolasa.
 * @author Dombai Balazs
 */
public class Params {
	
    /**
     * Parameterek.
     */
    private double t, r, mu, lambda;
    private int length_sum;
	
    public Params(Params params, int length_sum) {
	this.t = params.get_t();
	this.r = params.get_r();
	this.mu = params.get_mu();
	this.lambda = params.get_lambda();
	this.length_sum = length_sum;
    }
	
    public Params(double t, double r, double lambda, int length_sum) {
	set_t(t);
	set_r(r);
	this.length_sum = length_sum;
	set_lambda(lambda);
    }
	
    public void set_t(double new_t) {
	t = new_t;
	if (t <= 0) t = (double)1/Integer.MAX_VALUE;
	if (t >= 1) t = 1 - (double)1/Integer.MAX_VALUE;
    }
	
    public void set_r(double new_r) {
	r = new_r;
	if (r <= 0) r = (double)1/Integer.MAX_VALUE;
	if (r >= 1) r = 1 - (double)1/Integer.MAX_VALUE;
    }
	
    public void set_lambda(double new_lambda) {
	lambda = new_lambda;
	if (lambda <= 0) lambda = (double)1/(Integer.MAX_VALUE);
	if (lambda >= 1) lambda = 1- (double)1/(Integer.MAX_VALUE-2);
	mu = (length_sum + 2) * lambda / (length_sum);
	if (mu <= 0) mu = (double)1/(Integer.MAX_VALUE-2);
	if (mu >= 1) mu = 1 - (double)1/(Integer.MAX_VALUE);
    }
	
    public double get_t() {
	return t;
    }
	
    public double get_r() {
	return r;
    }
	
    public double get_mu() {
	return mu;
    }
	
    public double get_lambda() {
	return lambda;
    }
	
    public void addToValue(int position, double value) {
	switch (position) {
	case 1: {
	    set_t(t + value);
	    break;
	}
	case 2: {
	    set_r(r + value);
	    break;
	}
	case 3: {
	    set_lambda(lambda + value);
	    break;
	}
	}
    }
    /**
     * Returns a string representation of the object.
     * @return a string representation of the object
     */
    public String toString() {
	return get_t() +" "+ get_r() +" "+ get_mu() +" "+ get_lambda();
    }
	
}
