/**
 * A Viterbi-algoritmus illesztesi eredmenyeinek tarolasa
 * @author Dombai Balazs
 */
public class ResultSet {
	
	private double[] values;
	private String[] names;
	private int maxpos;
	
	public ResultSet(int length) {
		values = new double[length];
		names = new String[length];
		maxpos = -1;
	}
	
	public void set(int pos, String name, double value) {
		values[pos] = value;
		names[pos] = name;
		maxpos = Math.max(maxpos, pos);
	}
	
	public void setName(int pos, String name) {
		names[pos] = name;
		maxpos = Math.max(maxpos, pos);
	}
	
	public void setValue(int pos, double value) {
		values[pos] = value;
		maxpos = Math.max(maxpos, pos);
	}
	
	public String getName(int pos) {
		return names[pos];
	}
	
	public double getValue(int pos) {
		return values[pos];
	}
	
	public void write() {
		for (int i = 0; i <= maxpos; i++) {
			System.out.println(names[i] + " " + values[i]);
		}
	}
	
	public int getMaxPos() {
		return maxpos;
	}
	
}
